'''
Created on Nov 21, 2011

@author: vikturek
'''

import sys
import os
import random

def generateTestInt(testInput):
    if os.path.exists(testInput):
        os.remove(testInput)
    rand = random
    testFile = file(testInput, "w")
    testFile.write("INT\n")
    for i in range(0, 1000):
        testFile.write("ADD ")
        testFile.write(str(rand.randint(0, 1000)) + "\n")
    for i in range(0, 8000):
        if i % 2 == 1:
            testFile.write("ADD ")
        else:
            testFile.write("DEL ")
        testFile.write(str(rand.randint(0, 1000)) + "\n")
    for i in range(0, 1000):
        testFile.write("DEL ")
        testFile.write(str(rand.randint(0, 1000)) + "\n")
    testFile.close()

def generateTestDouble(testInput):
    if os.path.exists(testInput):
        os.remove(testInput)
    rand = random
    testFile = file(testInput, "w")
    testFile.write("DOUBLE\n")
    for i in range(0, 1000):
        testFile.write("ADD ")
        r = rand.uniform(0, 1000) / 100.0
        testFile.write(str(r) + "\n")
    for i in range(0, 8000):
        if i % 2 == 0:
            testFile.write("ADD ")
        else:
            testFile.write("DEL ")
        r = rand.uniform(0, 1000) / 100.0
        testFile.write(str(r) + "\n")
    for i in range(0, 1000):
        testFile.write("DEL ")
        r = rand.uniform(0, 1000) / 100.0
        testFile.write(str(r) + "\n")
    testFile.close()

def generateTestString(testInput):
    if os.path.exists(testInput):
        os.remove(testInput)
    rand = random
    text = ""
    testFile = file(testInput, "w")
    testFile.write("STRING\n")
    for i in range(0, 1000):
        testFile.write("ADD ")
        testFile.write(text + str(rand.randint(0, 1000)) + "\n")
    for i in range(0, 8000):
        if i % 2 == 1:
            testFile.write("ADD ")
        else:
            testFile.write("DEL ")
        testFile.write(text + str(rand.randint(0, 1000)) + "\n")
    for i in range(0, 1000):
        testFile.write("DEL ")
        testFile.write(text + str(rand.randint(0, 1000)) + "\n")
    testFile.close()
    
def generateTestPerformance(testInput):
    if os.path.exists(testInput):
        os.remove(testInput)
    rand = random
    text = "abcdefghaijklmnopqrstuvwxyz012356789_"
    testFile = file(testInput, "w")
    testFile.write("STRING\n")
    for i in range(0, 1000):
        testFile.write("ADD ")
        testFile.write(text + str(rand.randint(0, 1000)) + "\n")
    for i in range(0, 8000):
        if i % 2 == 1:
            testFile.write("ADD ")
        else:
            testFile.write("DEL ")
        testFile.write(text + str(rand.randint(0, 1000)) + "\n")
    for i in range(0, 1000):
        testFile.write("DEL ")
        testFile.write(text + str(rand.randint(0, 1000)) + "\n")
    testFile.close()

if __name__ == '__main__':
    
    score = 0.0
    valgrind = False
    
    print "\nTester pro domaci ukol 4 predmetu PJC v zimnim semestru 2011\n"
    if len(sys.argv) == 3:
        if os.path.exists(sys.argv[1]):
            open(sys.argv[1])
        else:
            print "Chyba: Nemohu najit zadane referencni reseni!"
            sys.exit(1)
        if os.path.exists(sys.argv[2]):
            open(sys.argv[2])
        else:
            print "Chyba: Nemohu najit zadany zdrojovy soubor!"
            sys.exit(1)
    elif len(sys.argv) == 4:
        if sys.argv[3] != "-valgrind":
            print "Chyba: Poslednim argumentem muze byt pouze text \'-valgrind!\'"
            sys.exit(1)
        else:
            valgrind = True
    else:
        print "Tester vyzaduje jako prvni argument referencni reseni a jako druhy nazev zdrojoveho kodu k testovani. \
Tretim nepovinnym argumentem je prikaz -valgrind, ktery otestuje kod i na memory leaky \
(- funguje pouze na linuxu s nainstalovanym valgrindem)."
        sys.exit(0)
    
    printOut = "\tKompiluji zadany zdrojovy soubor ... "
    retVal = os.system("g++ -o testApp -Wall -pedantic -Werror -pedantic-errors " + sys.argv[2] + " 2> compileLog.txt" )
    if retVal != 0:
        printOut += "Chyba!"
        print printOut
        print "\n\tZdrojovy kod se nepodarilo prelozit."
        print "\tKompletni log kompilace je ulozen v souboru compileLog.txt"
        sys.exit()
    printOut += "OK"
    print printOut
    
    sys.stdout.write("\n\tTest 1 - vstup podle ukazky z DU3 ... ")
    testInput = "inputs/test1"
    refOutput = "outputs/output1ref"
    testOutput = "outputs/output1test"  
    os.system("./" + sys.argv[1] + " " + testInput + " > " + refOutput)
    os.system("./testApp " + testInput + " > " + testOutput)
    if os.system("diff " + refOutput + " " + testOutput + " > /dev/null") == 0:
        sys.stdout.write("OK\n")
        score += 1000000
    else:
        sys.stdout.write("Chyba!\n")
        print "\n\tVystupy " + refOutput + " a " + testOutput + " nejsou stejne!"
    
    sys.stdout.write("\n\tTest 2 - zakladni odebirani prvku ... ")
    testInput = "inputs/test2"
    refOutput = "outputs/output2ref"
    testOutput = "outputs/output2test"
    os.system("./" + sys.argv[1] + " " + testInput + " > " + refOutput)
    os.system("./testApp " + testInput + " > " + testOutput)
    if os.system("diff " + refOutput + " " + testOutput + " > /dev/null") == 0:
        sys.stdout.write("OK\n")
        score += 100000
    else:
        sys.stdout.write("Chyba!\n")
        print "\n\tVystupy " + refOutput + " a " + testOutput + " nejsou stejne!"
    
    sys.stdout.write("\n\tTest 3 - nahodne prvky typu int ... ")
    testInput = "inputs/test3"
    generateTestInt(testInput)
    refOutput = "outputs/output3ref"
    testOutput = "outputs/output3test"
    os.system("./" + sys.argv[1] + " " + testInput + " > " + refOutput)
    os.system("./testApp " + testInput + " > " + testOutput)
    if os.system("diff " + refOutput + " " + testOutput + " > /dev/null") == 0:
        sys.stdout.write("OK\n")
        score += 10000
    else:
        sys.stdout.write("Chyba!\n")
        print "\n\tVystupy " + refOutput + " a " + testOutput + " nejsou stejne!"
    
    sys.stdout.write("\n\tTest 4 - nahodne prvky typu double ... ")
    testInput = "inputs/test4"
    generateTestDouble(testInput)
    refOutput = "outputs/output4ref"
    testOutput = "outputs/output4test"
    os.system("./" + sys.argv[1] + " " + testInput + " > " + refOutput)
    os.system("./testApp " + testInput + " > " + testOutput)
    if os.system("diff " + refOutput + " " + testOutput + " > /dev/null") == 0:
        sys.stdout.write("OK\n")
        score += 1000
    else:
        sys.stdout.write("Chyba!\n")
        print "\n\tVystupy " + refOutput + " a " + testOutput + " nejsou stejne!"
    
    sys.stdout.write("\n\tTest 5 - nahodne prvky typu string ... ")
    testInput = "inputs/test5"
    generateTestString(testInput)
    refOutput = "outputs/output5ref"
    testOutput = "outputs/output5test"
    os.system("./" + sys.argv[1] + " " + testInput + " > " + refOutput)
    os.system("./testApp " + testInput + " > " + testOutput)
    if os.system("diff " + refOutput + " " + testOutput + " > /dev/null") == 0:
        sys.stdout.write("OK\n")
        score += 100
    else:
        sys.stdout.write("Chyba!\n")
        print "\n\tVystupy " + refOutput + " a " + testOutput + " nejsou stejne!"
    
    sys.stdout.write("\n\tTest 6 - test rychlosti reseni ... ")
    testInput = "inputs/test6"
    generateTestPerformance(testInput)
    refOutput = "outputs/output6ref"
    testOutput = "outputs/output6test"
    os.system("./" + sys.argv[1] + " " + testInput + " --time-measure" + " > " + refOutput + " 2> timeRef")
    os.system("./testApp " + testInput + " --time-measure" + " > " + testOutput + " 2> timeTest")
    if os.system("diff " + refOutput + " " + testOutput + " > /dev/null") == 0:
        os.system("tail -1l timeRef > line")
        result = file("line", "r")
        timeRef = float(result.read())
        result.close()
        os.system("tail -1l timeTest > line")
        result = file("line", "r")
        timeTest = float(result.read())
        result.close()
        
        if timeRef * 1.2 >= timeTest:
            sys.stdout.write("OK\n")
            score += 10
        else:
            sys.stdout.write("Chyba!\n")
            print "\n\tDoba testovaneho reseni je vetsi nez 120% doby referencniho reseni!"
            print "\tDoba referencniho reseni: " + str(timeRef) + "s"
            print "\tDoba testovaneho reseni:  " + str(timeTest) + "s"
        
    else:
        sys.stdout.write("Chyba!\n")
        print "\n\tVystupy " + refOutput + " a " + testOutput + " nejsou stejne!"
        
    if valgrind:
        sys.stdout.write("\n\tTest 7 - test prace s pameti ... ")
        testInput = "inputs/test5"
        testOutput = "outputs/output7test"
        os.system("valgrind ./testApp " + testInput + " 2> " + testOutput + " > /dev/null")
        result = file(testOutput, "r")
        resultText = result.read()
        if resultText.count("in use at exit: 0 bytes in 0 blocks") == 0:
            print "Chyba pri vstupu \'" + testInput +"\' !"
            print "\n\tAplikace valgrind vratila nenulovy pocet chyb. Log valgrindu je v souboru " + testOutput + ".\n"
        else:
            print "OK\n"
            score += 1
    
    if score == 1111111:
        print "Dosazeno maximalni mozne hodnoceni. Blahopreji!"
    elif score > 1111100:
        if score > 1111110:
            if not valgrind:
                print "Pro maximalni hodnoceni je potreba spustit test 7 pomoci posledniho parametru \'-valgrind\'.\
Pokud netestujete na linuxu s nainstalovanym valgrindem, tak test 7 nespoustejte.\n" 
            else:
                print "Testy 1-6 splneny, ale aplikace nepracuje spravne s pameti.\n"
        else:
            print "Testy 1-5 splneny, ale nebyl splnen pozadavek na rychlost aplikace (test 6).\n"
    else:
        print "Testy 1-5 nebyly splneny!\n"
        
